
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"

extern void	Error(char *msg),
		ReadSliceImage(char *path,int Nx,int Ny,Cell **cell);

#ifndef	HT_T
#define HT_T	unsigned short
#endif

#define UL	unsigned long
#define PV	(Cell)(~0)

int	main(int argc,char **argv)
{
	char	**path,**last;
	int	Nx,Ny,Nz,x1,y1,z1,x2,y2,z2,z,y,x,x3,y3,z3,x4,y4,z4;
	Cell	***cell;
	UL	pv;
	HT_T	HT[PV+1],ht;

	if (argc!=3) Error("usage : si_cht directory nameFile");

	path=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	if ((cell=(Cell ***)malloc(sizeof(Cell **)*Nz))==NULL ||
	    (*cell=(Cell **)malloc(sizeof(Cell *)*Nz*Ny))==NULL ||
	    (**cell=(Cell *)malloc(sizeof(Cell)*Nz*Ny*Nx))==NULL)
	    Error("no allocatable memory for cell.");

	for (pv=0; pv<=PV; pv++) HT[pv]=0;

	x1=Nx; y1=Ny; z1=Nz; x2=y2=z2=(-1);
	for (z=0; z<Nz; z++) {
	    if (z==0)
		for (y=1; y<Ny; y++) cell[0][y]=cell[0][y-1]+Nx;
	    else {
		cell[z]=cell[z-1]+Ny;
		for (y=0; y<Ny; y++) cell[z][y]=cell[z][y-1]+Nx;
	    }
	    ReadSliceImage(path[z],Nx,Ny,cell[z]);

	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++)
		if (cell[z][y][x]) {
		    HT[cell[z][y][x]]=1; if (x<x1) x1=x; if (x>x2) x2=x;
					 if (y<y1) y1=y; if (y>y2) y2=y;
					 if (z<z1) z1=z; if (z>z2) z2=z;
		}
	}
	if (x1>x2 || y1>y2 || z1>z2) Error("no object area.");

	if ((last=(char **)malloc(sizeof(char *)*(1+Ny)))==NULL ||
	    (*last=(char *)malloc(sizeof(char)*(1+Ny)*(1+Nx)))==NULL)
	    Error("no allocatable memory for last.");

	++last; ++last[-1]; for (y=0; y<Ny; y++) last[y]=last[y-1]+1+Nx;

	for (ht=2;; ht++) {
	  for (x=x1; x<=x2; x++) last[y1-1][x]=0;
	  for (y=y1; y<=y2; y++) for (x=x1-1; x<=x2; x++) last[y][x]=0;

	  x3=x2+1; y3=y2+1; z3=z2+1; x4=x1-1; y4=y1-1; z4=z1-1;
	  for (z=z1; z<=z2; z++) {
	    for (y=y1; y<=y2; y++) {
	      for (x=x1; x<=x2; x++)
		if (cell[z][y][x])
		  if (last[y][x]==0)
		    last[y][x]=2;
		  else if (last[y][x]==1) {
		    if (last[y-1][x]==0 || last[y][x-1]==0) last[y][x]=2;

		    HT[cell[z-1][y][x]]=ht; if (x<x3) x3=x; if (x>x4) x4=x;
					    if (y<y3) y3=y; if (y>y4) y4=y;
					    if (z<z3) z3=z; if (z>z4) z4=z;
		  }
		  else {
		    cell[z-1][y][x]=0;
		    if (last[y-1][x]!=0 && last[y][x-1]!=0) last[y][x]=1;
		  }
		else {
		  if (last[y][x]!=0) {
		    cell[z-1][y][x]=0; last[y][x]=0;
		  }
		  if (last[y-1][x]==1) last[y-1][x]=2;
		  if (last[y][x-1]==1) last[y][x-1]=2;
		}

	      if (last[y][x2]==1) last[y][x2]=2;
            }
            for (x=x1+1; x<x2; x++) if (last[y2][x]==1) last[y2][x]=2;
	  }
	  for (y=y1; y<=y2; y++)
	  for (x=x1; x<=x2; x++) if (last[y][x]!=0) cell[z2][y][x]=0;

	  if ((x1=x3)>(x2=x4) ||
	      (y1=y3)>(y2=y4) || (z1=z3-1)>(z2=z4-1)) break;
	}
	for (pv=0; pv<=PV; pv++)
	    if (HT[pv]) (void)printf("%lu\t%lu\n",(UL)pv,(UL)HT[pv]);

	return 0;
}
