
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"

extern void	Error(char *msg),
		ReadSliceImage(char *path,int X,int Y,Cell **cell);

#ifndef	HT_T
#define HT_T	unsigned short
#endif

#define PV	(Cell)(~0)

int	main(int ac,char **av)
{
	char	**path;
	int	X,Y,Z,z,y,x1,y1,z1,x2,y2,z2,x,x3,y3,z3,x4,y4,z4;
	Cell	***C1,***C2,pv,***C;
	HT_T	HT[PV],ht;

	if (ac!=3) Error("usage : si_cht_1 directory nameFile");

	path=CheckSliceImages(av[1],av[2],&X,&Y,&Z,NULL);

	if ((C1=(Cell ***)malloc(sizeof(Cell **)*Z))==NULL ||
	    (*C1=(Cell **)malloc(sizeof(Cell *)*Z*Y))==NULL ||
	    (**C1=(Cell *)malloc(sizeof(Cell)*Z*Y*X))==NULL ||
	    (C2=(Cell ***)malloc(sizeof(Cell **)*(Z+2)))==NULL ||
	    (*C2=(Cell **)malloc(sizeof(Cell *)*(Z+2)*(Y+2)))==NULL ||
	    (**C2=(Cell *)malloc(sizeof(Cell)*(Z+2)*(Y+2)*(X+2)))==NULL)
	    Error("memory allocation error.");

	for (z=0; z<Z; z++) {
	    if (z>=1) C1[z]=C1[z-1]+Y;

	    for (y=0; y<Y; y++) if (z>=1 || y>=1) C1[z][y]=C1[z][y-1]+X;

	    ReadSliceImage(path[z],X,Y,C1[z]);
	}
	for (pv=0; pv<PV; pv++) HT[pv]=0;

	++C2; ++C2[-1]; ++C2[-1][-1]; x1=X; y1=Y; z1=Z; x2=y2=z2=(-1);
	for (z=(-1); z<=Z; z++) {
	    if (z>=0) C2[z]=C2[z-1]+Y+2;

	    for (y=(-1); y<=Y; y++) {
		if (z>=0 || y>=0) C2[z][y]=C2[z][y-1]+X+2;

		for (x=(-1); x<=X; x++)
		    if (x>=0 && x<X &&
			y>=0 && y<Y &&
			z>=0 && z<Z && (pv=C1[z][y][x])>0) {
			HT[(C2[z][y][x]=pv)-1]=1;
			if (x<x1) x1=x; if (x>x2) x2=x;
			if (y<y1) y1=y; if (y>y2) y2=y;
			if (z<z1) z1=z; if (z>z2) z2=z;
		    }
		    else
			C2[z][y][x]=0;
	    }
	}
	for (ht=2;; ht++) {
	    x3=x2+1; y3=y2+1; z3=z2+1; x4=x1-1; y4=y1-1; z4=z1-1;
	    for (z=z1; z<=z2; z++)
	    for (y=y1; y<=y2; y++)
	    for (x=x1; x<=x2; x++)
		if (		     C2[z-1][y  ][x] &&
				     C2[z  ][y-1][x] &&
		    C2[z][y][x-1] && C2[z  ][y  ][x] && C2[z][y][x+1] &&
				     C2[z  ][y+1][x] &&
				     C2[z+1][y  ][x]) {
		    HT[C2[z][y][x]-1]=ht; if (x<x3) x3=x; if (x>x4) x4=x;
					  if (y<y3) y3=y; if (y>y4) y4=y;
					  if (z<z3) z3=z; if (z>z4) z4=z;
		}
		else
		    C1[z][y][x]=0;

	    if ((x1=x3)>(x2=x4) || (y1=y3)>(y2=y4) || (z1=z3)>(z2=z4)) break;

	    C=C1; C1=C2; C2=C;
	}
	for (pv=0; pv<PV; pv++)
	    if ((ht=HT[pv])>0) (void)printf("%lu\t%lu\n",(unsigned long)pv+1,
							 (unsigned long)ht);

	return 0;
}
