
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"
#include "sif.h"

extern void	Error(),RangeList(),ReadSliceImage();

#define PV	(Cell)(~0)
#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**paths,pv01[(size_t)PV+1],**last,path[LEN];
	int	Nx,Ny,Nz,x1,y1,z1,x2,y2,z2,z,y,x,x3,x4,y3,y4,z3,z4,len,bps;
	Cell	***cell;
	size_t	layer,next;

	if (argc!=4 && argc!=5)
	    Error("usage : si_lm orgDir nameFile rangeList {newDir}");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	RangeList(argv[3],(size_t)PV,pv01);

#define ALLOC(type,size)	(type *)malloc(sizeof(type)*size)

	if ((cell=ALLOC(Cell **,(size_t)Nz))==NULL ||
	    (*cell=ALLOC(Cell *,(size_t)Nz*(size_t)Ny))==NULL ||
	    (**cell=ALLOC(Cell,(size_t)Nz*(size_t)Ny*(size_t)Nx))==NULL)
	    Error("no allocatable memory for cell.");

	x1=Nx; y1=Ny; z1=Nz; x2=y2=z2=(-1);
	for (z=0; z<Nz; z++) {
	    if (z==0)
		for (y=1; y<Ny; y++) cell[0][y]=cell[0][y-1]+Nx;
	    else {
		cell[z]=cell[z-1]+Ny;
		for (y=0; y<Ny; y++) cell[z][y]=cell[z][y-1]+Nx;
	    }
	    ReadSliceImage(paths[z],Nx,Ny,cell[z]);

	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++)
		if (cell[z][y][x]=pv01[cell[z][y][x]]) {
		    if (x<x1) x1=x; if (x>x2) x2=x;
		    if (y<y1) y1=y; if (y>y2) y2=y;
		    if (z<z1) z1=z; if (z>z2) z2=z;
		}
	}
	if (x1>x2 || y1>y2 || z1>z2) Error("no object area.");

	if ((last=ALLOC(char *,(size_t)(1+Ny)))==NULL ||
            (*last=ALLOC(char,(size_t)(1+Ny)*(size_t)(1+Nx)))==NULL)
	    Error("no allocatable memory for last.");

	++last; ++last[-1]; for (y=0; y<Ny; y++) last[y]=last[y-1]+1+Nx;

	for (layer=next=1; layer<PV; layer=next) {
	    for (y=y1-1; y<=y2; y++)
	    for (x=x1-1; x<=x2; x++) last[y][x]=0;

	    for (z=z1; z<=z2; z++) {
		for (y=y1; y<=y2; y++) {
		    for (x=x1; x<=x2; x++)
			if (cell[z][y][x]==layer)
			    if (last[y][x]==0)
				last[y][x]=2;
			    else if (last[y][x]==1) {
				if (last[y-1][x]==0 ||
				    last[y][x-1]==0) last[y][x]=2;

				if (layer==next) {
				    ++next; x3=x4=x; y3=y4=y; z3=z4=z;
				}
				else /* if (layer!=next) */ {
				    if (x<x3) x3=x; else if (x>x4) x4=x;
				    if (y<y3) y3=y; else if (y>y4) y4=y;
				    if (z<z3) z3=z; else if (z>z4) z4=z;
				}
				cell[z-1][y][x]=(Cell)next;
			    }
			    else /* if (last[y][x]==2) */ {
				if (last[y-1][x]!=0 &&
				    last[y][x-1]!=0) last[y][x]=1;
			    }
			else /* if (cell[z][y][x]!=layer) */ {
			    if (last[y][x]!=0) last[y][x]=0;

			    if (last[y-1][x]==1) last[y-1][x]=2;
			    if (last[y][x-1]==1) last[y][x-1]=2;
			}

		    if (last[y][x2]==1) last[y][x2]=2;
		}
		for (x=x1+1; x<x2; x++) if (last[y2][x]==1) last[y2][x]=2;
	    }
	    if (layer==next) break;

	    x1=x3; y1=y3; z1=z3-1; x2=x4; y2=y4; z2=z4-1;
	}
	(void)printf("%lu\n",(unsigned long)layer);

	if (argc==5) {
	    for (len=1; argv[1][len-1]!='\0'; len++) ;

	    for (bps=1; 1<<bps<=layer; bps<<=1) ;

	    for (z=0; z<Nz; z++) {
		(void)sprintf(path,"%s/%s",argv[4],paths[z]+len);
		StoreImageFile(path,Nx,Ny,bps,cell[z],NULL);
	    }
	}
	return 0;
}
