
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cell.h"
#include "csi.h"
#include "sif.h"

#ifndef	LABEL_T
#define LABEL_T	unsigned int
#endif

extern void	Error(),RangeList(),ReadSliceImage();

static LABEL_T	Trace(link,old)
LABEL_T		*link,old;
{
	LABEL_T	new=link[old];

	return (new==0)?old:(link[old]=Trace(link,new));
}

#define PV	(Cell)(~0)
#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**paths,pv01[(size_t)PV+1],path[LEN];
	int	Nx,Ny,Nz,Nt,y,X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4,Nt2,z,x,
		x1,y1,x2,y2,t,x3,y3,x4,y4;
	Cell	**cell;
	LABEL_T	*last,Nl,*link,l,lx;
	size_t	len;

	if (argc!=5 && argc!=6)
	Error("usage : si_osp2 orgDir nameFile rangeList thickness {newDir}");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	RangeList(argv[3],(size_t)PV,pv01);

	if ((Nt=atoi(argv[4]))<0) Error("bad thickness.");

#define ALLOC(type,size)	(type *)malloc(sizeof(type)*(size_t)(size))

	if ((cell=ALLOC(Cell *,Ny))==NULL ||
	    (*cell=ALLOC(Cell,(size_t)Ny*(size_t)Nx))==NULL)
	    Error("no allocatable memory for cell.");

	for (y=1; y<Ny; y++) cell[y]=cell[y-1]+Nx;

	if ((last=ALLOC(LABEL_T,1+Nx))==NULL)
	    Error("no allocatable memory for last.");

	++last; last[-1]=1;

	X1=X3=Nx; Y1=Y3=Ny; Z1=Z3=Nz; X2=Y2=Z2=X4=Y4=Z4=(-1); Nt2=Nt*2;

	if (argc==6) len=strlen(argv[1])+1;

	for (z=0; z<Nz; z++) {
	    ReadSliceImage(paths[z],Nx,Ny,cell);

	    for (x=0; x<Nx; x++) last[x]=1;

	    x1=Nx; y1=Ny; x2=y2=(-1);
	    for (Nl=2, y=0; y<Ny; y++) for (x=0; x<Nx; x++)
		if (cell[y][x]=pv01[cell[y][x]]) {
		    last[x]=0; if (x<x1) x1=x; if (x>x2) x2=x;
			       if (y<y1) y1=y; if (y>y2) y2=y;
		}
		else {
		    if (!last[x] && !last[x-1])
			if (++Nl>(LABEL_T)(~0)/sizeof(LABEL_T))
			    Error("too many links.");

		    last[x]=1; 
		}

	    if (x1>x2 || y1>y2) goto Store;

	    if (x1<X1) X1=x1; if (x2>X2) X2=x2;
	    if (y1<Y1) Y1=y1; if (y2>Y2) Y2=y2; if (z<Z1) Z1=z; if (z>Z2) Z2=z;

	    if (x2-x1<=Nt2 || y2-y1<=Nt2) {
		for (y=y1; y<=y2; y++)
		for (x=x1; x<=x2; x++) cell[y][x]=0; goto Store;
	    }
	    if ((link=ALLOC(LABEL_T,Nl-1))==NULL)
		Error("no allocatable memory for link.");

	    --link; link[1]=0;

	    for (x=x1; x<=x2; x++) last[x]=1;

	    for (Nl=2, y=y1; y<=y2; y++) {
		for (x=x1; x<=x2; x++)
		    if (cell[y][x])
			last[x]=0;
		    else if ((l=last[x])!=0) {
			l=Trace(link,l);
			if ((lx=last[x-1])!=0 && (lx=Trace(link,lx))!=l)
			    if (lx==1) l=link[l]=1; else link[lx]=l;

			last[x]=l;
		    }
		    else if ((l=last[x-1])!=0)
			last[x]=Trace(link,l);
		    else
			link[last[x]=Nl++]=0;

		if (y>y1 && x2>x1)
		    if ((l=last[x2])!=0 && (l=Trace(link,l))!=1) link[l]=1;
	    }
	    if (y2>y1)
		for (x=x1+1; x<x2; x++)
		    if ((l=last[x])!=0 && (l=Trace(link,l))!=1) link[l]=1;

	    for (l=2; l<Nl; l++) if (link[l]!=0) (void)Trace(link,l);
	    for (l=2; l<Nl; l++) if (link[l]==0) link[l]=l;

	    for (x=x1; x<=x2; x++) last[x]=1;

	    for (Nl=2, y=y1; y<=y2; y++) for (x=x1; x<=x2; x++)
		if (cell[y][x])
		    last[x]=0;
		else {
		    if ((l=last[x  ])==0 &&
			(l=last[x-1])==0) l=link[Nl++];

		    if ((last[x]=l)!=1) cell[y][x]=1;
		}

	    free(link+1);

	    for (t=0; t<Nt; t++) {

#include "e2.h"

		if (x1>x2 || y1>y2) goto Store;
	    }
	    if (x1<X3) X3=x1; if (x2>X4) X4=x2;
	    if (y1<Y3) Y3=y1; if (y2>Y4) Y4=y2; if (z<Z3) Z3=z; if (z>Z4) Z4=z;
Store:;
	    if (argc==6) {
		(void)sprintf(path,"%s/%s",argv[5],paths[z]+len);
		StoreImageFile(path,Nx,Ny,1,cell,NULL);
	    }
	}
	if (X1>X2 || Y1>Y2 || Z1>Z2) Error("no object area.");

	(void)printf("%d\t%d\t%d\t%d\t%d\t%d\n",X1,Y1,Z1,X2,Y2,Z2);

	if (X3>X4 || Y3>Y4 || Z3>Z4) Error("missing object area.");

	(void)printf("%d\t%d\t%d\t%d\t%d\t%d\n",X3,Y3,Z3,X4,Y4,Z4);

	return 0;
}
