
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"

extern void	Error(char *msg);

#ifndef	HT_T
#define HT_T	unsigned short
#endif

#define UL	unsigned long
#define PV	(Cell)(~0)

int	main(int argc,char **argv)
{
	int	Nx,Ny,x1,y1,x2,y2,y,x,x3,y3,x4,y4;
	Cell	**cell;
	UL	pv;
	HT_T	HT[PV+1],ht;
	char	*last;

	if (argc!=2) Error("usage : t_cht TIFF");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	for (pv=0; pv<=PV; pv++) HT[pv]=0;

	x1=Nx; y1=Ny; x2=y2=(-1);
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++)
	    if (cell[y][x]) {
		HT[cell[y][x]]=1; if (x<x1) x1=x; if (x>x2) x2=x;
				  if (y<y1) y1=y; if (y>y2) y2=y;
	    }

	if (x1>x2 || y1>y2) Error("no object area.");

	if ((last=(char *)malloc((size_t)(1+Nx)))==NULL)
	    Error("no allocatable memory for last.");

	++last;

	for (ht=2;; ht++) {
	    for (x=x1-1; x<=x2; x++) last[x]=0;

	    x3=x2+1; y3=y2+1; x4=x1-1; y4=y1-1;
	    for (y=y1; y<=y2; y++) {
		for (x=x1; x<=x2; x++)
		    if (cell[y][x])
			if (last[x]==0)
			    last[x]=2;
			else if (last[x]==1) {
			    if (last[x-1]==0) last[x]=2;

			    HT[cell[y-1][x]]=ht; if (x<x3) x3=x; if (x>x4) x4=x;
						 if (y<y3) y3=y; if (y>y4) y4=y;
			}
			else {
			    cell[y-1][x]=0; if (last[x-1]!=0) last[x]=1;
			}
		    else {
			if (last[x]!=0) {
			    cell[y-1][x]=0; last[x]=0;
			}
			if (last[x-1]==1) last[x-1]=2;
		    }

		if (last[x2]==1) last[x2]=2;
	    }
	    for (x=x1; x<=x2; x++) if (last[x]!=0) cell[y2][x]=0;

	    if ((x1=x3)>(x2=x4) || (y1=y3-1)>(y2=y4-1)) break;
	}
	for (pv=0; pv<=PV; pv++)
	    if (HT[pv]) (void)printf("%lu\t%lu\n",(UL)pv,(UL)HT[pv]);

	return 0;
}
