
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"

extern void	Error(char *msg);

#ifndef	HT_T
#define HT_T	unsigned short
#endif

#define PV	(Cell)(~0)

int	main(int ac,char **av)
{
	int	X,Y,x1,y1,x2,y2,y,x,x3,y3,x4,y4;
	Cell	**C1,**C2,pv,**C;
	HT_T	HT[PV],ht;

	if (ac!=2) Error("usage : t_cht_2 TIFF");

	ReadImageFile(av[1],&X,&Y,NULL,&C1,NULL);

	if ((C2=(Cell **)malloc(sizeof(Cell *)*(Y+2)))==NULL ||
	    (*C2=(Cell *)malloc(sizeof(Cell)*(Y+2)*(X+2)))==NULL)
	    Error("memory allocation error.");

	for (pv=0; pv<PV; pv++) HT[pv]=0;

	++C2; ++C2[-1]; x1=X; y1=Y; x2=y2=(-1);
	for (y=(-1); y<=Y; y++) {
	    if (y>=0) C2[y]=C2[y-1]+X+2;

	    for (x=(-1); x<=X; x++)
		if (x>=0 && x<X && y>=0 && y<Y && (pv=C1[y][x])>0) {
		    HT[(C2[y][x]=pv)-1]=1; if (x<x1) x1=x; if (x>x2) x2=x;
					   if (y<y1) y1=y; if (y>y2) y2=y;
		}
		else
		    C2[y][x]=0;
	}
	for (ht=2;; ht++) {
	    x3=x2+1; y3=y2+1; x4=x1-1; y4=y1-1;
	    for (y=y1; y<=y2; y++)
	    for (x=x1; x<=x2; x++)
		if (C2[y-1][x-1] && C2[y-1][x] && C2[y-1][x+1] &&
		    C2[y  ][x-1] && C2[y  ][x] && C2[y  ][x+1] &&
		    C2[y+1][x-1] && C2[y+1][x] && C2[y+1][x+1]) {
		    HT[C2[y][x]-1]=ht; if (x<x3) x3=x; if (x>x4) x4=x;
				       if (y<y3) y3=y; if (y>y4) y4=y;
		}
		else
		    C1[y][x]=0;

	    if ((x1=x3)>(x2=x4) || (y1=y3)>(y2=y4)) break;

	    C=C1; C1=C2; C2=C;
	}
	for (pv=0; pv<PV; pv++)
	    if ((ht=HT[pv])>0) (void)printf("%lu\t%lu\n",(unsigned long)pv+1,
							 (unsigned long)ht);

	return 0;
}
