
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error(),RangeList();

#define PV	(Cell)(~0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,Nl,x,x1,y1,x2,y2,y,l,x3,y3,x4,y4;
	Cell	**cell;
	char	pv01[(size_t)PV+1],*last,*moa="missing object area.";

	if (argc!=4 && argc!=5)
	    Error("usage : t_ed orgTIFF rangeList layers {newTIFF}");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	RangeList(argv[2],(size_t)PV,pv01);

	if ((Nl=atoi(argv[3]))<0) Error("bad layers.");

	if ((last=(char *)malloc((size_t)(1+Nx)))==NULL)
	    Error("no allocatable memory for last.");

	++last;

	x1=Nx; y1=Ny; x2=y2=(-1);
	for (y=0; y<Ny; y++) for (x=0; x<Nx; x++)
	    if (cell[y][x]=pv01[cell[y][x]]) {
		if (x<x1) x1=x; if (x>x2) x2=x;
		if (y<y1) y1=y; if (y>y2) y2=y;
	    }

	if (x1>x2 || y1>y2) Error("no object area.");

	(void)printf("%d\t%d\t%d\t%d\n",x1,y1,x2,y2);

	l=Nl*2; if (x2-x1<=l || y2-y1<=l) Error(moa);

	for (l=0; l<Nl; l++) {

#include "e2.h"

	    if (x1>x2 || y1>y2) Error(moa);
	}
	(void)printf("%d\t%d\t%d\t%d\n",x1,y1,x2,y2);

	for (l=0; l<Nl; l++) {

#include "d2.h"

	}
	(void)printf("%d\t%d\t%d\t%d\n",x1,y1,x2,y2);

	if (argc==5) StoreImageFile(argv[4],Nx,Ny,1,cell,NULL);

	return 0;
}
