
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error(),RangeList();

#define PV	(Cell)(~0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,Ne,Nd,Nl,Nxl,Nyl,Lx,Ly,y,x,l,x1,y1,x2,y2,x3,y3,x4,y4;
	Cell	**cell;
	char	pv01[(size_t)PV+1],*last,
		*namfc="no allocatable memory for cell.",
		*moa="missing object area.";

	if (argc!=5 && argc!=6)
	    Error("usage : t_eda orgTIFF rangeList erosion dilation {newTIFF}");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	RangeList(argv[2],(size_t)PV,pv01);

	if ((Ne=atoi(argv[3]))<0 ||
	    (Nd=atoi(argv[4]))<0) Error("bad layers.");

	Nl=(Nd>Ne)?Nd-Ne:0; Nxl=Nx+Nl; Lx=Nl+Nxl;
			    Nyl=Ny+Nl; Ly=Nl+Nyl;

#define SIZE(type,size)	sizeof(type)*(size_t)(size)

	if (Nl>0) {
	    if ((cell=(Cell **)
		 realloc(cell,SIZE(Cell *,Ly)))==NULL) Error(namfc);

	    for (y=Nyl-1; y>=Nl; y--) {
		if ((cell[y]=(Cell *)
		     realloc(cell[y-Nl],SIZE(Cell,Lx)))==NULL) Error(namfc);

		for (x=Nxl-1; x>=Nl; x--) cell[y][x]=cell[y][x-Nl];

		for (x=Nxl, l=0; l<Nl; l++, x++) cell[y][l]=cell[y][x]=0;
	    }
	    for (y=Nyl, l=0; l<Nl; l++, y++) {
		if ((cell[l]=(Cell *)malloc(SIZE(Cell,Lx)))==NULL ||
		    (cell[y]=(Cell *)malloc(SIZE(Cell,Lx)))==NULL) Error(namfc);

		for (x=0; x<Lx; x++) cell[l][x]=cell[y][x]=0;
	    }
	}
	if ((last=(char *)malloc((size_t)(1+Lx)))==NULL)
	    Error("no allocatable memory for last.");

	++last;

	x1=Nxl; y1=Nyl; x2=y2=Nl-1;
	for (y=Nl; y<Nyl; y++) for (x=Nl; x<Nxl; x++)
	    if (cell[y][x]=pv01[cell[y][x]]) {
		if (x<x1) x1=x; if (x>x2) x2=x;
		if (y<y1) y1=y; if (y>y2) y2=y;
	    }

	if (x1>x2 || y1>y2) Error("no object area.");

	(void)printf("%d\t%d\t%d\t%d\n",x1-Nl,y1-Nl,x2-Nl,y2-Nl);

	l=Ne*2; if (x2-x1<=l || y2-y1<=l) Error(moa);

	for (l=0; l<Ne; l++) {

#include "e2.h"

	    if (x1>x2 || y1>y2) Error(moa);
	}
	(void)printf("%d\t%d\t%d\t%d\n",x1-Nl,y1-Nl,x2-Nl,y2-Nl);

	for (l=0; l<Nd; l++) {

#include "d2.h"

	}
	(void)printf("%d\t%d\t%d\t%d\n",x1-Nl,y1-Nl,x2-Nl,y2-Nl);

	if (argc==6) {
	    for (y=y1; y<=y2; y++) cell[y]+=x1;

	    StoreImageFile(argv[5],x2-x1+1,y2-y1+1,1,cell+y1,NULL);
	}
	return 0;
}
