
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error(),RangeList();

#define PV	(Cell)(~0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,x1,y1,x2,y2,y,x,x3,x4,y3,y4,bps;
	Cell	**cell;
	char	pv01[(size_t)PV+1],*last;
	size_t	layer,next;

	if (argc!=3 && argc!=4)
	    Error("usage : t_lm orgTIFF rangeList {newTIFF}");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	RangeList(argv[2],(size_t)PV,pv01);

	x1=Nx; y1=Ny; x2=y2=(-1);
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++)
	    if (cell[y][x]=pv01[cell[y][x]]) {
		if (x<x1) x1=x; if (x>x2) x2=x;
		if (y<y1) y1=y; if (y>y2) y2=y;
	    }

	if (x1>x2 || y1>y2) Error("no object area.");

	if ((last=(char *)malloc((size_t)(1+Nx)))==NULL)
	    Error("no allocatable memory for last.");

	++last;

	for (layer=next=1; layer<PV; layer=next) {
	    for (x=x1-1; x<=x2; x++) last[x]=0;

	    for (y=y1; y<=y2; y++) {
		for (x=x1; x<=x2; x++)
		    if (cell[y][x]==layer)
			if (last[x]==0)
			    last[x]=2;
			else if (last[x]==1) {
			    if (last[x-1]==0) last[x]=2;

			    if (layer==next) {
				++next; x3=x4=x; y3=y4=y;
			    }
			    else /* if (layer!=next) */ {
				if (x<x3) x3=x; else if (x>x4) x4=x;
				if (y<y3) y3=y; else if (y>y4) y4=y;
			    }
			    cell[y-1][x]=(Cell)next;
			}
			else /* if (last[x]==2) */ {
			    if (last[x-1]!=0) last[x]=1;
			}
		    else /* if (cell[y][x]!=layer) */ {
			if (last[x]!=0) last[x]=0;

			if (last[x-1]==1) last[x-1]=2;
		    }

		if (last[x2]==1) last[x2]=2;
	    }
	    if (layer==next) break;

	    x1=x3; y1=y3-1; x2=x4; y2=y4-1;
	}
	(void)printf("%lu\n",(unsigned long)layer);

	if (argc==4) {
	    for (bps=1; 1<<bps<=layer; bps<<=1) ;

	    StoreImageFile(argv[3],Nx,Ny,bps,cell,NULL);
	}
	return 0;
}
