
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error(char *msg),
		RangeList(char *str,size_t lim,char *pv);

#define PV	(Cell)(~0)

int	main(int ac,char **av)
{
	int	X,Y,x1,y1,x2,y2,y,x,x3,y3,x4,y4,bps;
	Cell	**C1,**C2,l,n,**C;
	char	pv[(size_t)PV+1];

	if (ac!=3 && ac!=4) Error("usage : t_lm_1 orgTIFF rangeList {newTIFF}");

	ReadImageFile(av[1],&X,&Y,NULL,&C1,NULL);

	RangeList(av[2],PV,pv);

	if ((C2=(Cell **)malloc(sizeof(Cell *)*(Y+2)))==NULL ||
	    (*C2=(Cell *)malloc(sizeof(Cell)*(Y+2)*(X+2)))==NULL)
	    Error("memory allocation error.");

	++C2; ++C2[-1]; x1=X; y1=Y; x2=y2=(-1);
	for (y=(-1); y<=Y; y++) {
	    if (y>=0) C2[y]=C2[y-1]+X+2;

	    for (x=(-1); x<=X; x++)
		if (x>=0 && x<X && y>=0 && y<Y && pv[C1[y][x]]) {
		    C2[y][x]=1; if (x<x1) x1=x; if (x>x2) x2=x;
				if (y<y1) y1=y; if (y>y2) y2=y;
		}
		else
		    C2[y][x]=0;
	}
	for (l=n=1; l<PV; l=n) {
	    for (y=y1; y<=y2; y++)
	    for (x=x1; x<=x2; x++)
		if (		    C2[y-1][x]<l ||
		    C2[y][x-1]<l || C2[y  ][x]<l || C2[y][x+1]<l ||
				    C2[y+1][x]<l)
		    C1[y][x]=C2[y][x];
		else {
		    if (l==n) {
			++n; x3=x4=x; y3=y4=y;
		    }
		    else {
			if (x<x3) x3=x; else if (x>x4) x4=x;
			if (y<y3) y3=y; else if (y>y4) y4=y;
		    }
		    C1[y][x]=n;
		}

	    if (l==n) break;

	    C=C1; C1=C2; C2=C; x1=x3; y1=y3; x2=x4; y2=y4;
	}
	(void)printf("%lu\n",(unsigned long)l);

	if (ac==4) {
	    for (bps=1; 1<<bps<=l; bps<<=1) ;

	    StoreImageFile(av[3],X,Y,bps,C2,NULL);
	}
        return 0;
}
