
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

#ifndef	LABEL_T
#define LABEL_T	unsigned int
#endif

extern void	Error(),RangeList();

static LABEL_T	Trace(link,old)
LABEL_T		*link,old;
{
	LABEL_T	new=link[old];

	return (new==0)?old:(link[old]=Trace(link,new));
}

#define PV	(Cell)(~0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,Nt,x,x1,y1,x2,y2,y,t,x3,y3,x4,y4;
	Cell	**cell;
	char	pv01[(size_t)PV+1],*moa="missing object area.";
	LABEL_T	*last,Nl,*link,l,lx;

	if (argc!=4 && argc!=5)
	    Error("usage : t_osp orgTIFF rangeList thickness {newTIFF}");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	RangeList(argv[2],(size_t)PV,pv01);

	if ((Nt=atoi(argv[3]))<0) Error("bad thickness.");

#define ALLOC(type,size)	(type *)malloc(sizeof(type)*(size_t)(size))

	if ((last=ALLOC(LABEL_T,1+Nx))==NULL)
	    Error("no allocatable memory for last.");

	++last; for (x=(-1); x<Nx; x++) last[x]=1;

	x1=Nx; y1=Ny; x2=y2=(-1);
	for (Nl=2, y=0; y<Ny; y++) for (x=0; x<Nx; x++)
	    if (cell[y][x]=pv01[cell[y][x]]) {
		last[x]=0; if (x<x1) x1=x; if (x>x2) x2=x;
			   if (y<y1) y1=y; if (y>y2) y2=y;
	    }
	    else {
		if (!last[x] && !last[x-1])
		    if (++Nl>(LABEL_T)(~0)/sizeof(LABEL_T))
			Error("too many links.");

		last[x]=1; 
	    }

	if (x1>x2 || y1>y2) Error("no object area.");

	(void)printf("%d\t%d\t%d\t%d\n",x1,y1,x2,y2);

	t=Nt*2; if (x2-x1<=t || y2-y1<=t) Error(moa);

	if ((link=ALLOC(LABEL_T,Nl-1))==NULL)
	    Error("no allocatable memory for link.");

	--link; link[1]=0;

	for (x=x1; x<=x2; x++) last[x]=1;

	for (Nl=2, y=y1; y<=y2; y++) {
	    for (x=x1; x<=x2; x++)
		if (cell[y][x])
		    last[x]=0;
		else if ((l=last[x])!=0) {
		    l=Trace(link,l);
		    if ((lx=last[x-1])!=0 && (lx=Trace(link,lx))!=l)
			if (lx==1) l=link[l]=1; else link[lx]=l;

		    last[x]=l;
		}
		else if ((l=last[x-1])!=0)
		    last[x]=Trace(link,l);
		else
		    link[last[x]=Nl++]=0;

	    if (y>y1 && x2>x1)
		if ((l=last[x2])!=0 && (l=Trace(link,l))!=1) link[l]=1;
	}
	if (y2>y1)
	    for (x=x1+1; x<x2; x++)
		if ((l=last[x])!=0 && (l=Trace(link,l))!=1) link[l]=1;

	for (l=2; l<Nl; l++) if (link[l]!=0) (void)Trace(link,l);
	for (l=2; l<Nl; l++) if (link[l]==0) link[l]=l;

	for (x=x1; x<=x2; x++) last[x]=1;

	for (Nl=2, y=y1; y<=y2; y++) for (x=x1; x<=x2; x++)
	    if (cell[y][x])
		last[x]=0;
	    else {
		if ((l=last[x  ])==0 &&
		    (l=last[x-1])==0) l=link[Nl++];

		if ((last[x]=l)!=1) cell[y][x]=1;
	    }

	free(link+1);

	for (t=0; t<Nt; t++) {

#include "e2.h"

	    if (x1>x2 || y1>y2) Error(moa);
	}
	(void)printf("%d\t%d\t%d\t%d\n",x1,y1,x2,y2);

	if (argc==5) StoreImageFile(argv[4],Nx,Ny,1,cell,NULL);

	return 0;
}
